unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
  Dialogs, StdCtrls, LMessages, LCLIntf;

type

  { TMyEdit }

  TMyEdit = class(TCustomEdit)
  private
    FExtCursorReadOnly: TCursor;
    function GetReadOnly: Boolean;
    procedure SetReadOnly(AValue: Boolean);
    procedure SetExtCursorReadOnly(AValue: TCursor);
  public
    constructor Create(AOwner: TComponent); override;
  published
    property ExtCursorReadOnly: TCursor read FExtCursorReadOnly write SetExtCursorReadOnly default crDefault;
    property ReadOnly: Boolean read GetReadOnly write SetReadOnly;
  end;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyEdit: TMyEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyEdit := TMyEdit.Create(Self);
  MyEdit.Left := 10;
  MyEdit.Top  := 10;
  MyEdit.Parent := Form1;
  MyEdit.Text := 'Test';
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  MyEdit.ReadOnly := Checkbox1.Checked;
end;

{ TMyEdit }

procedure TMyEdit.SetExtCursorReadOnly(AValue: TCursor);
begin
  if FExtCursorReadOnly = AValue then Exit;
  FExtCursorReadOnly := AValue;
end;

procedure TMyEdit.SetReadOnly(AValue: Boolean);
begin
  inherited ReadOnly := AValue;
  if ReadOnly then Cursor := FExtCursorReadOnly else Cursor := inherited Cursor;
end;

function TMyEdit.GetReadOnly: Boolean;
begin
  Result := inherited ReadOnly;
end;

constructor TMyEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FExtCursorReadOnly := crNoDrop;
end;

end.

